;
; html-nikki-helper.el by Jun Obama <george@yk.rim.or.jp>
;   Special thanks to TAMURA Kent <tkent@din.or.jp>
;
; INSTALL:
;   1.Put this file to a directory in load-path.
;   2.Add following line to your ~/.emacs:
;       (require 'html-nikki-helper)
;
;----------
;
; Setting for html-helper-mode:
;     add following line to your ~/.emacs:
;
;       (add-hook 'html-helper-mode-hook
;         '(lambda () 
;            (progn
;              (require 'html-nikki-helper)
;              (define-key html-helper-mode-map "\C-cd" 'html-nikki-insert-date)
;              (define-key html-helper-mode-map "\C-u\C-cd" 'html-nikki-insert-date-offset)
;              (define-key html-helper-mode-map "\C-ce" 'html-nikki-insert-paragraph-title))) t)
;
;----------
;
; Setting for XEmacs 20.4 sgml-mode:
;     add following line to your ~/.emacs:
;
;       (add-hook 'sgml-mode-hook
;         '(lambda () 
;            (progn
;              (require 'html-nikki-helper)
;              (define-key sgml-mode-map "\C-cd" 'html-nikki-insert-date)
;              (define-key sgml-mode-map "\C-ce" 'html-nikki-insert-paragraph-title))) t)
;
;
(provide 'html-nikki-helper)
;
; set default value
;
(defvar baseurl "http://www.ceres.dti.ne.jp/~george/")
;
; $BF|IU%?%0A^F~(B
;
;$B8=:_$NF|IU$r?tCM2=$7$?$b$N(B($B$?$H$($P(B19980327)$B$r(Bname$B%?%0$H$7$FF|IU6h@Z$j(B
;$B%?%0$r8=:_$N%P%C%U%!$KA^F~$9$k!#(B
;
(defun html-nikki-insert-date (&optional OFFSET-DAY)
  (interactive)
  (let (datestr tagstr str offsetsec specified-time)
    (setq offsetsec (* 3600 24 (or OFFSET-DAY 0) ))
    (setq specified-time 
	  (html-nikki-add-time (current-time) (list 0 offsetsec)))
    (setq datestr (strftime "%y.%m.%d (%a)" specified-time))
    (setq tagstr (strftime "%y%m%d" specified-time))
    (insert "<hr>"
	    "\n"
	    "<h3><a name=\"" tagstr "\">$B"#(B $B1'ChNr(B " datestr "</a></h3>"
	    "\n"
	    "<div class=right>"
	    "<a href=\""
	    (buffer-name)
	    "#" tagstr "\">" baseurl (buffer-name) "#" tagstr "</a>"
	    "</div>"
	    "\n")))
;
; $BF|IU%?%0A^F~(B
;
;  $B8=:_$NF|IU$+$iA08e$K(Bn$BF|$rLd$$9g$o$;$F(B
;  $BF|IU%?%0$r8=:_$N%P%C%U%!$KA^F~$9$k!#(B
;
(defun html-nikki-insert-date-offset-interactive ()
  (list (string-to-int (read-string "input date offset : " "" ))))
;
(defun html-nikki-insert-date-offset (offsetday)
  (interactive
   (html-nikki-insert-date-offset-interactive))
  (message "day of offset is %d" offsetday)
  (html-nikki-insert-date offsetday))
;
; $BCJMn%?%0A^F~(B
;
;backward$BJ}8~$KF|IU%?%0(B(<a name="19980327">$B$N$h$&$K!"(Bname$B%?%0$NFbMF$,(B8
;$B7e$N?t;z$K$J$C$F$$$k$b$N(B)$B$,$"$l$P!"$=$l$rMxMQ$7$F(B1998032701$B$H$$$&(Bname
;$B%?%0$r:n@.!#(B
;
;backward$BJ}8~$KCJMn%?%0(B(<a name="1998032701">$B$N$h$&$K!"(Bname$B%?%0$NFbMF$,(B
;10$B7e$N?t;z$K$J$C$F$$$k$b$N(B)$B$,$"$l$P!":G8e$N(B2$B7e$N?t;z$r(B+1$B$7$F!"(B
;1998032702$B$H$$$&(Bname$B%?%0$r:n@.!#(B
;
(defun html-nikki-insert-paragraph-title ()
  (interactive)
  (let (tagstr ptagstr sp ep tmp dif)
    (setq tagstr (strftime "%y%m%d"))
    (setq ptagstr "01")
    (save-excursion
      (cond ((search-backward-regexp "<[aA] [nN][aA][mM][eE]=\"[^<>\"]*" 0 t)
	     (setq sp (+ (match-beginning 0) 9))
	     (setq ep (+ (match-beginning 0) 9 8))
	     (setq tagstr (buffer-substring sp ep))
	     (setq dif (- (match-end 0) (match-beginning 0)))
	     (cond ((equal dif 19)
		    (setq sp (- (match-end 0) 2))
		    (setq ep (match-end 0))
		    (setq ptagstr (format "%02d" (+ 1 (string-to-int (buffer-substring sp ep))))))))))
    (insert "<h4>"
	    "<a name=\"" tagstr ptagstr "\"> </a>"
	    "<a href=\"" 
	    (buffer-name)
	    "#" tagstr ptagstr "\">"
	    "  </a>"
	    "</h4>\n"
	    "<p>\n"
	    "\n"
	    "</p>\n")
    (search-backward " </a>")
    ))

;
; $BC1=c$JCJMn%?%0(B <p></p>$BA^F~(B
;
(defun html-nikki-insert-paragraph ()
  (interactive)
  (let ()
    (insert "<p>\n"
	    "\n"
	    "</p>\n")
    (forward-line -2)
    ))

;
; minimum subset of strftime :-)
;
(defun strftime (&optional fmt SPECIFIED-TIME)
  (let (str week month-name month day time year timelist ret)
    (setq str (current-time-string SPECIFIED-TIME))
    (setq timelist (html-table-region-split-string-to-list str))
    (setq week (car timelist))
    (setq timelist (cdr timelist))
    (setq month-name (car timelist))
    (setq month (month-name-to-number-string month-name))
    (setq timelist (cdr timelist))
    (setq day (format "%02d" (string-to-int (car timelist))))
    (setq timelist (cdr timelist))
    (setq time (car timelist))
    (setq timelist (cdr timelist))
    (setq year (car timelist))
    (cond ((equal fmt "%y.%m.%d") (setq ret (concat year "." month "." day)))
	  ((equal fmt "%y%m%d") (setq ret (concat year month day)))
	  ((equal fmt "%y.%m.%d (%a)") (setq ret (concat year "." month "." day " (" week ")")))
	  ((t) (setq ret (concat year month day))))
	   
    ret))

;
; convert month short name to number string
;   by KENT TAMURA Kent <tkent@din.or.jp>
;
(defconst html-nikki-helper-month-number-alist
          '(("Jan" . "01") ("Feb" . "02") ("Mar" . "03") ("Apr" . "04")
            ("May" . "05") ("Jun" . "06") ("Jul" . "07") ("Aug" . "08")
            ("Sep" . "09") ("Oct" . "10") ("Nov" . "11") ("Dec" . "12")))
(defun month-name-to-number-string (mon)
  (cdr (assoc mon html-nikki-helper-month-number-alist)))

;
;  add time
;    $B;~4V$N:9J,7W;;$r9T$&(B
;    ( MSB-side-16bit LSB-side-16bit . micro-second )
;    $B7A<0$N;~4V(B($BIC(B)$B$rB-$7;;$7$F7k2L$rJV$9(B
;    $BNc(B:(html-nikki-add-time (list 1 1) (list 0 0))
;
(defun html-nikki-add-time (x y)
  (let (xh xl)
    (setq xh (+ (car x) (car y)))
    (setq xl (+ (cadr x) (cadr y)))
    (while (< xl 0)   
      (setq xh (- xh 1))
      (setq xl (+ xl 65536)))
    (while (< 65536 xl) 
      (setq xh (+ xh 1))
      (setq xl (- xl 65536)))
    (list xh xl 0)  ))

;
; FreeBSD-users-jp ML $B$X$N%j%s%/$rA^F~$9$k$?$a$N%3!<%I(B
;
(defvar mailing-list-name "freebsd-users-jp")
(defvar mailing-list-number 1)

(defun html-nikki-insert-mailing-list-link-interactive (prompt-ml-name default-ml-name prompt-ml-number default-ml-number)
  (list (read-string prompt-ml-name default-ml-name)
	(string-to-int(read-string prompt-ml-number (format "%d" default-ml-number)))))

(defun html-nikki-insert-mailing-list-link (ml-name ml-num)
  "insert hyper link to freebsd-users-jp mailing list web site."
  (interactive
   (html-nikki-insert-mailing-list-link-interactive
    "Mailing list name   : " mailing-list-name
    "Mailing list number : " mailing-list-number))
  (setq mailing-list-name ml-name)
  (setq mailing-list-number ml-num)
  (insert
    (format "<a href=\"http://home.jp.freebsd.org/cgi-bin/showmail/%s/%d\"> %s [%d] </a>"
	    mailing-list-name
	    mailing-list-number
	    mailing-list-name
	    mailing-list-number)))

;
; end of file
;

