#!/bin/sh

#
# user defines
#
CACHEDIR_ORIG=${HOME}/.netscape.461.pkg
CACHEDIR=${HOME}/.netscape

#
# create cache directory each version of communicator
#
if [ ! -d ${CACHEDIR_ORIG} ]; then
	mkdir -m 700 ${CACHEDIR_ORIG}
	cp /usr/local/lib/netscape/preferences.js ${CACHEDIR_ORIG}
	chmod 644 ${CACHEDIR_ORIG}/preferences.js
fi

#
# relink cache directory.
#   to use different version of Netscape Communicator alternativly.
#
alreadylink=0
if [ -f ${CACHEDIR} ] ; then
	echo ${CACHEDIR} is normal file.  abort.
	exit 1
elif [ -h ${CACHEDIR} ] ; then
	alreadylink=1
elif [ \! -d ${CACHEDIR} ] ; then
	ln -s ${CACHEDIR_ORIG} ${CACHEDIR}
fi

#
# set environ
#
export LANG=ja_JP.EUC
export LC_ALL=${LANG}
export LC_CTYPE=${LANG}
export MOZILLA_HOME=/usr/local/lib/netscape
export CLASSPATH=.:${MOZILLA_HOME}
export NS_NETHELP_PATH=${MOZILLA_HOME}/${LANG}
export XKEYSYMDB=/usr/X11R6/lib/X11/XKeysymDB
export XAPPLRESDIR=/usr/local/lib/netscape
export TIMID_DIR=/usr/local/lib/timidity
export XCMSDB=/dev/null
if [ -e /usr/local/lib/aout/libxpg4-ns.so.2.0 ]; then
	export LD_PRELOAD=/usr/local/lib/aout/libxpg4-ns.so.2.0
elif [ x$JA_NETSCAPE_USE_LD_PRELOAD != x -a x$JA_NETSCAPE_USE_LD_PRELOAD != xno ]; then
	export LD_PRELOAD=libxpg4.so.2.0
else
	export PATH_LOCALE=/usr/local/lib/netscape/locale
fi
#
# exec communicator
#
${MOZILLA_HOME}/communicator-4.61.bin "$@"

#
# remove virtual cache directory link.
#
if [ -h ${CACHEDIR} -a ${alreadylink} -ne 1 ] ; then
	rm ${CACHEDIR}
fi
#
# end of file
#
